require = GLOBAL.require
local TUNING = GLOBAL.TUNING
local GetPlayer = GLOBAL.GetPlayer
local GetPlayer = GLOBAL.GetPlayer
local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local ACTIONS = GLOBAL.ACTIONS
local Vector3 = GLOBAL.Vector3
local distsq = GLOBAL.distsq
local GetWorld = GLOBAL.GetWorld
local Prefabs = GLOBAL.Prefabs
local Transform = GLOBAL.Transform
local Physics = GLOBAL.Physics
local AnimState = GLOBAL.AnimState
local FRAMES = GLOBAL.FRAMES
local DEGREES = GLOBAL.DEGREES
local SpawnPrefab = GLOBAL.SpawnPrefab
local TheCamera = GLOBAL.TheCamera
local seg_time = 30
local day_segs = 10
local dusk_segs = 4
local night_segs = 2
local day_time = seg_time * day_segs
local dusk_time = seg_time * dusk_segs
local night_time = seg_time * night_segs
local total_day_time = seg_time*16
local TheSim = GLOBAL.TheSim
local SpawnPrefab = GLOBAL.SpawnPrefab

local randomchestloot = 
{
	"seaweed",
	"seaweed",
	"seaweed",
	"seaweed",
	"seaweed",
	"seashell",
	"seashell",
	"seashell",
	"coral",
	"coral",
	"coral",
	"shark_fin",
	"blubber",
}

local chestloot =
{
	californiaroll = "sail",
	seafoodgumbo = "clothsail",
	bisque = "trawlnet",
	jellyopop = "seatrap",
	ceviche = "telescope",
	surfnturf = "boat_lantern",
	lobsterbisque = "piratehat",
	lobsterdinner = "boatcannon",
}

local function OnGetItemFromPlayer(inst, giver, item)
	local istrinket = item:HasTag("trinket")
	inst.components.trader:Disable()
	inst.AnimState:PlayAnimation("happy")
	inst.AnimState:PushAnimation("grabchest")
	inst.AnimState:PushAnimation("idle", true)
	inst:DoTaskInTime(13*FRAMES, function(inst)	inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/octopus_king/happy") end)
	inst:DoTaskInTime(53*FRAMES, function(inst)	inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/octopus_king/tenticle_out_water") end)
	inst:DoTaskInTime(71*FRAMES, function(inst)	inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/octopus_king/tenticle_in_water") end)
	inst:DoTaskInTime(78*FRAMES, function(inst)	inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/seacreature_movement/splash_small") end)
	inst:DoTaskInTime(109*FRAMES, function(inst)
		inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/octopus_king/tenticle_out_water")
		local down = GLOBAL.TheCamera:GetDownVec()
		local spawnangle = math.atan2(down.z, down.x) + -50*DEGREES
		local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
		local sp = math.random()*3+2
		local chest = SpawnPrefab("octopuschest")
		local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(2*math.cos(spawnangle), 2, 2*math.sin(spawnangle))
		if chest then
			chest.Transform:SetPosition(pt:Get())
			chest.Physics:SetVel(sp*math.cos(angle), math.random()*2+9, sp*math.sin(angle))
			chest.components.inventoryitem:OnStartFalling()
			chest.AnimState:PlayAnimation("air_loop", true)
			chest.components.floatable:SetOnHitWaterFn(function()
				chest.AnimState:PlayAnimation("land")
					chest.AnimState:PushAnimation("closed", true)
			end)
			if not istrinket then
				local single = SpawnPrefab("dubloon")
				chest.components.container:GiveItem(single, nil, nil, true, false)
				if chestloot[item.prefab] then
					local goodreward = SpawnPrefab(chestloot[item.prefab])
					chest.components.container:GiveItem(goodreward, nil, nil, true, false)
				else
					local dubloonvalue = math.min(item.components.tradable.dubloonvalue, 2)
					for i = 1, dubloonvalue do
						local loot = SpawnPrefab(randomchestloot[math.random(1, #randomchestloot)])
						chest.components.container:GiveItem(loot, nil, nil, true, false)
					end
				end
			else
				for i = 1, item.components.tradable.dubloonvalue do
					local loot = SpawnPrefab("dubloon")
					chest.components.container:GiveItem(loot, nil, nil, true, false)
				end
			end
			if not TheSim:FindFirstEntityWithTag("woodlegs_key2") and not GLOBAL.Profile:IsCharacterUnlocked("woodlegs") then
				if math.random() < 0.1 then
					local loot = SpawnPrefab("woodlegs_key2")
					chest.components.container:GiveItem(loot, nil, nil, true, false)
				end
			end
		end
	end)
	inst.happy = true
	if inst.endhappytask then
		inst.endhappytask:Cancel()
	end
	inst.endhappytask = inst:DoTaskInTime(5, function(inst)
		inst.happy = false
		inst.endhappytask = nil
		inst.components.trader:Enable()
		--FinishedTrading(inst)
	end)
end
local function NewTrade(inst)
	inst.components.trader.onaccept = OnGetItemFromPlayer
end
AddPrefabPostInit("octopusking",NewTrade)

if(GetModConfigData("increase_dublon_value") == "Yes") then
	TUNING.DUBLOON_VALUES=
	{
		SEAFOOD = 3,
		RARESEAFOOD = 15,
		TRINKETS=
		{
			18,24,18,21,18,21,18,27,27,12,21,27,
			12,12,15,6,6,24,15,24,15,6,24,
		}
	}
end